<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xrl="http://netkernel.org/xrl">
    <xsl:output method="html"/>
	<xsl:param name="param"><hds></hds></xsl:param>
	<xsl:param name="status"></xsl:param>
	
	<xsl:variable name="imgbase">/tools/introspect/pub/</xsl:variable>
	
    <xsl:template match="/hds">
		<div>

				<xrl:include>
				 <xrl:identifier>active:controlPanelInfoBox</xrl:identifier>
				 <xrl:argument name="content">
				   <div>
             <p>
               The Representation Cache holds resource representations returned from requests.
             </p>
             <p>
               The first line contains cache summary information including
               the results of the last cache cull.
             </p>
             <p>
               The main table lists the actual cached representations
               (the representation can be viewed by clicking on its resource identifier).
               The table supports sorting and filtering.
             </p>
             <p>
               The entire cache can be cleared by clicking on the button labeled &quot;empty cache&quot;.
             </p>
				   <p>
             Cache parameters can be configured in the
             <a href="/tools/kernelconfig">Configure NetKernel</a> tool.
           </p>
				   </div>
				 </xrl:argument>
				</xrl:include> 

				<script type="text/javascript">
				<xsl:comment>
					
					function handleOver(event,id)
					{ 
						e=document.getElementById(id);
					    e.style.top=event.y+50;
						e.style.display= ""
					}

					function handleOut(id)
	                { document.getElementById(id).style.display= "none"
					}
					
					function sort(sortby)
					{	document.form.sortby.value=sortby;
						document.form.submit();
					}
					function onClear()
					{	document.form.action2.value='clear';
						document.form.submit();
					}
				</xsl:comment>
				</script>
				<div>
				<form action="" name="form" method="post">
					<input type="hidden" name="sortby" value="{$param/hds/sortby}"/>
					<input type="hidden" name="action2" value=""/>
					<table class="form-table"><tr>
					
					<td style="font-weight:bold">Filter:</td>
					<td><input type="text" name="match" value="{$param/hds/match}" title="string contains filter for resource identifier"/></td>
					<td style="font-weight:bold">Display:</td>
					<td><input type="text" name="max" size="3" value="{$param/hds/max}" style="text-align: right;"/></td>
					<td><input type="submit" name="refresh" value="refresh" class="btn"/></td>
					<td><input type="button" onclick="onClear()" value="empty cache" class="btn"/></td>
					</tr></table>
				</form>
				</div>
				<xsl:variable name="omitted" select="$status/hds/count - count(item)"/>
				<table class="data-table" width="100%">
				<tr class="vis-title">
				<td>Items</td>
				<td>Not Shown</td>
				<td>Total</td>
				<td>Hit Rate</td>
				<td>Last Cull Status</td>
				</tr>
				<tr>
				<td><xsl:value-of select="count(item)"/></td>
				<td><xsl:value-of select="$omitted"/></td>
				<td><xsl:value-of select="$status/hds/size"/></td>
				<td><xsl:value-of select="$status/hds/hitPercent"/>%</td>
				<td><xsl:value-of select="$status/hds/status"/></td>
				</tr>
				</table>
				
				<table class="data-table" width="100%">
					<tr class="vis-title">
						<td>Verb</td>
						<td>Resource Identifier
							<xsl:call-template name="sortButtons">
								<xsl:with-param name="key" select="'id'"/>
							</xsl:call-template>
						</td>
						<td>Representation
							<xsl:call-template name="sortButtons">
								<xsl:with-param name="key" select="'class'"/>
							</xsl:call-template>							
						</td>
						<td class="cost">Cost
							<xsl:call-template name="sortButtons">
								<xsl:with-param name="key" select="'cost'"/>
							</xsl:call-template>
						</td>
						<td class="hits">Hits
							<xsl:call-template name="sortButtons">
								<xsl:with-param name="key" select="'hit'"/>
							</xsl:call-template>
						</td>
						<td class="age">Age
							<xsl:call-template name="sortButtons">
								<xsl:with-param name="key" select="'age'"/>
							</xsl:call-template>
						</td>
						<td class="boost">Boost
							<xsl:call-template name="sortButtons">
								<xsl:with-param name="key" select="'boost'"/>
							</xsl:call-template>
						</td>
						<td class="index">Idx
							<xsl:call-template name="sortButtons">
								<xsl:with-param name="key" select="'index'"/>
							</xsl:call-template>
						</td>
					</tr>
					<xsl:apply-templates select="item"/>
				</table>
		</div>
	</xsl:template>
	
	
	<xsl:template match="item">
		<xsl:variable name="class">
			<xsl:choose>
				<xsl:when test="position() mod 2 = 0">
					<xsl:text>evenrow</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>oddrow</xsl:text>
				</xsl:otherwise>  
			</xsl:choose>
		</xsl:variable>
		<tr class="{$class}">
			<td><xsl:value-of select="verb"/></td>
			<td class="uri" >
				<a class="identifier" href="/tools/cache-representation?view={hash}">
					<xsl:choose>
						<xsl:when test="string-length(id)">
							<xsl:value-of select="id"/>
						</xsl:when>
						<xsl:otherwise>&lt;empty_string&gt;</xsl:otherwise>
					</xsl:choose>
				</a>
			</td>
			<td class="class" >
				<xsl:call-template name="substring-after-last">
					<xsl:with-param name="string" select="class" />
					<xsl:with-param name="delimiter" select="'.'" />
				</xsl:call-template>				
			</td>
			<td class="cost"><xsl:value-of select="cost"/></td>
			<td class="hits"><xsl:value-of select="hit"/></td>
			<td class="age"><xsl:value-of select="age"/></td>
			<td class="boost"><xsl:value-of select="boost"/></td>
			<td class="index"><xsl:value-of select="index"/></td>
		</tr>
		<tr style="font-size: 80%; background: none;">
			<td/>
			<td colspan="7" >
				<xsl:for-each select="scopes/scope">
							<div>
								<xsl:for-each select="s">
									<xsl:value-of select="."/>...
								</xsl:for-each>
							</div>
				</xsl:for-each>			
			</td>
		</tr>
		
	</xsl:template>
	
	<xsl:template name="substring-after-last">
	  <xsl:param name="string" />
	  <xsl:param name="delimiter" />
	  <xsl:choose>
		<xsl:when test="contains($string, $delimiter)">
		  <xsl:call-template name="substring-after-last">
			<xsl:with-param name="string"
			  select="substring-after($string, $delimiter)" />
			<xsl:with-param name="delimiter" select="$delimiter" />
		  </xsl:call-template>
		</xsl:when>
		<xsl:otherwise><xsl:value-of select="$string" /></xsl:otherwise>
	  </xsl:choose>
	</xsl:template>	
	
	<xsl:template name="sortButtons">
		<xsl:param name="key"/>
	
		<xsl:choose>
			<xsl:when test="$param/hds/sortby=$key">
					<a href="javascript:sort('{$key}')"><img  src="{$imgbase}upSelected.png" alt="[^]"/></a>
			</xsl:when>
			<xsl:otherwise>
				<a href="javascript:sort('{$key}')"><img  src="{$imgbase}up.png" alt="[^]"/></a>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="$param/hds/sortby=concat($key,'Rev')">
					<a href="javascript:sort('{$key}Rev')"><img  src="{$imgbase}downSelected.png" alt="[v]"/></a>
			</xsl:when>
			<xsl:otherwise>
				<a href="javascript:sort('{$key}Rev')"><img  src="{$imgbase}down.png" alt="[v]"/></a>
			</xsl:otherwise>
		</xsl:choose>
	
	</xsl:template>	
	
	<xsl:template name="expiry">
		<div>
			<xsl:value-of select="@msg"/>
			<xsl:if test="e">
				<div style="margin-left: 1em;">
				<xsl:for-each select="e">
					<xsl:call-template name="expiry"/>
				</xsl:for-each>
				</div>
			</xsl:if>
		</div>
	</xsl:template>		

</xsl:stylesheet>
