package tools.cr;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.nkf.impl.NKFRequestImpl;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.request.IRequestScopeLevel;
import org.netkernel.request.impl.RequestScopeLevelImpl;
import org.netkernel.urii.ISpace;


public class ContextResourceEndpoint extends StandardAccessorImpl
{
	public ContextResourceEndpoint()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String identifier = aContext.getThisRequest().getIdentifier();
		String hash=identifier.substring(19);
		int i=hash.indexOf('/');
		i=hash.indexOf('/',i+1);
		String resourceIdentifier=hash.substring(i+1);
		hash=hash.substring(0,i);
		
		IRepDeployedModules deployedModules=(IRepDeployedModules)aContext.source("active:moduleList",IRepDeployedModules.class);
		Object found=deployedModules.componentForHash(hash);
		if (found!=null && found instanceof ISpace)
		{	INKFRequest req=aContext.createRequest(resourceIdentifier);
			IRequestScopeLevel rctx = RequestScopeLevelImpl.createOrphanedRootScopeLevel((ISpace)found,aContext.getKernelContext().getThisKernelRequest().getRequestScope());
			((NKFRequestImpl)req).setRequestScope(rctx);
			req.setRepresentationClass(aContext.getThisRequest().getRepresentationClass());
			
			if(aContext.getThisRequest().getIdentifier().endsWith("png"))
			{	Object rep=aContext.issueRequest(req);
				INKFResponse resp=aContext.createResponseFrom(rep);
				resp.setHeader("HTTP_CACHE_EXPIRES_DELTA_SECONDS", "86400");
				resp.setMimeType("image/png");
			}
			else
			{
				INKFResponseReadOnly resp=aContext.issueRequestForResponse(req);
				aContext.createResponseFrom(resp);
			}
		}
		else
		{	throw new NKFException("Unknown Space");
		}
	}
}