<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xrl="http://netkernel.org/xrl">
	<xsl:output method="xml" />
	<xsl:param name="param" />
	<xsl:variable name="imgbase">/tools/introspect/pub/</xsl:variable>

	<xsl:template match="/modules" >
		<div>
			<style type="text/css"><xsl:comment>
				.disabled-module { color: #888; }
				.disabled-module td { color: #888; }
				.disabled-module a { color: #888; }
			</xsl:comment></style>
			
				<xrl:include>
				 <xrl:identifier>active:controlPanelInfoBox</xrl:identifier>
				 <xrl:argument name="content">
				   <div>
				   <p>The Deployment Editor shows the module configuration of the NetKernel instance. Modules can be converted between their expanded
				   and jar-ed forms, enabled and disabled and their runlevel changed.
				   </p>
				   <p>Click on the module to open it's details or to change it's configuration</p>
				   
				   <p><b>Stem modules can be viewed but not edited by this tool.</b></p>
				   </div>
				 </xrl:argument>
				</xrl:include>
				
				<xsl:choose>
					<xsl:when test="$param/hds/action2='edit'">
						<xsl:call-template name="edit"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="list"/>
					</xsl:otherwise>
				</xsl:choose>
			</div>
		</xsl:template>
		
		<xsl:template name="list">
		
				<script type="text/javascript">
				<xsl:comment>
					
					function submitEdit(src)
					{	document.actionsform.src.value=src;
						document.actionsform.submit();
					}
				</xsl:comment>
				</script>
		
			
			<form name="actionsform" method="post">
				<input type="hidden" name="action2" value="edit"/>
				<input type="hidden" name="src" value=""/>
				
			<table class="data-table" style="border-spacing: 0px;">
				
				<tr class="vis-title">
					<td>Module
						<xsl:call-template name="sortButtons">
							<xsl:with-param name="key" select="'module'"/>
						</xsl:call-template>
					</td>
					<td>Runlevel
						<xsl:call-template name="sortButtons">
							<xsl:with-param name="key" select="'runlevel'"/>
						</xsl:call-template>
					</td>
					<td>Expanded
						<xsl:call-template name="sortButtons">
							<xsl:with-param name="key" select="'expanded'"/>
						</xsl:call-template>
					</td>
					<td>Enabled
						<xsl:call-template name="sortButtons">
							<xsl:with-param name="key" select="'enabled'"/>
						</xsl:call-template>
					</td>
				</tr>
				
				<xsl:choose>
					<xsl:when test="$param/hds/sortby='module'">
						<xsl:apply-templates select="module">
							<xsl:sort select="id"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:when test="$param/hds/sortby='moduleRev'">
						<xsl:apply-templates select="module">
							<xsl:sort select="id" order="descending"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:when test="$param/hds/sortby='runlevel'">
						<xsl:apply-templates select="module[runlevel!='*']">
							<xsl:sort select="runlevel" data-type="number" order="ascending" />
						</xsl:apply-templates>
						<xsl:apply-templates select="module[runlevel='*']"/>
					</xsl:when>
					<xsl:when test="$param/hds/sortby='runlevelRev'">
						<xsl:apply-templates select="module[runlevel='*']"/>
						<xsl:apply-templates select="module[runlevel!='*']">
							<xsl:sort select="runlevel" data-type="number" order="descending"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:when test="$param/hds/sortby='expandedRev'">
						<xsl:apply-templates select="module">
							<xsl:sort select="jar"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:when test="$param/hds/sortby='expanded'">
						<xsl:apply-templates select="module">
							<xsl:sort select="jar" order="descending"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:when test="$param/hds/sortby='enabled'">
						<xsl:apply-templates select="module">
							<xsl:sort select="enabled"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:when test="$param/hds/sortby='enabledRev'">
						<xsl:apply-templates select="module">
							<xsl:sort select="enabled" order="descending"/>
						</xsl:apply-templates>
					</xsl:when>
				</xsl:choose>
			
			</table>
			</form>
	</xsl:template>
	
	<xsl:template match="module">
				
		<tr>
			<xsl:choose>
				<xsl:when test="id and runlevel&lt;='1'">
					<td><xsl:value-of select="id"/></td>
				</xsl:when>
				<xsl:when test="id">
					<td><a onclick="submitEdit('{src}')"><xsl:value-of select="id"/></a></td>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="class">disabled-module</xsl:attribute>
					<td><a onclick="submitEdit('{src}')"><xsl:value-of select="src"/></a></td>
				</xsl:otherwise>
			</xsl:choose>
			<td style="text-align: center;"><xsl:value-of select="runlevel"/></td>
			<td style="text-align: center;"><input type="checkbox" disabled="">
				<xsl:if test="jar='false'"><xsl:attribute name="checked"/></xsl:if>
				</input>
			</td>
			<td style="text-align: center;"><input type="checkbox" disabled="">
				<xsl:if test="enabled='true'"><xsl:attribute name="checked"/></xsl:if>
				</input>
			</td>
		</tr>
	
	</xsl:template>
	
	<xsl:template name="sortButtons">
		<xsl:param name="key"/>
	
		<xsl:choose>
			<xsl:when test="$param/hds/sortby=$key">
					<a href="?sortby={$key}"><img  src="{$imgbase}upSelected.png" alt="[^]"/></a>
			</xsl:when>
			<xsl:otherwise>
				<a href="?sortby={$key}"><img  src="{$imgbase}up.png" alt="[^]"/></a>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="$param/hds/sortby=concat($key,'Rev')">
					<a href="?sortby={$key}Rev"><img  src="{$imgbase}downSelected.png" alt="[v]"/></a>
			</xsl:when>
			<xsl:otherwise>
				<a href="?sortby={$key}Rev"><img  src="{$imgbase}down.png" alt="[v]"/></a>
			</xsl:otherwise>
		</xsl:choose>
	
	</xsl:template>	
	
	<xsl:template name="edit">
		<xsl:variable name="module" select="/modules/module[src=$param/hds/src]"/>
		<form method="post" name="actionsform">
			<input type="hidden" name="action2" value="update" />
			<input type="hidden" name="src" value="{$module/src}" />
		
			<table class="data-table">
				<tr>
					<td class="label">Id:</td>
					<td>
						<xsl:choose>
							<xsl:when test="$module/id"><xsl:value-of select="$module/id"/>
							</xsl:when>
							<xsl:otherwise>
							</xsl:otherwise>
						</xsl:choose>
						
					</td>
				</tr>
			
				<tr>
					<td class="label">Source:</td>
					<td><xsl:value-of select="$module/src"/></td>
				</tr>
				<tr>
					<td class="label">Runlevel:</td>
					<td><input type="text" name="runlevel" size="2" value="{$module/runlevel}"/></td>
				</tr>
				<tr>
					<td class="label">Enabled:</td>
					<td>
						<input type="checkbox" name="enabled">
							<xsl:if test="$module/enabled='true'"><xsl:attribute name="checked"/></xsl:if>
						</input>
					</td>
				</tr>
				<tr>
					<td class="label">Expanded:</td>
					<td>
						<input type="checkbox" name="expanded">
							<xsl:if test="$module/jar='false'"><xsl:attribute name="checked"/></xsl:if>
						</input>
					</td>
				</tr>
				<tr>
					<td/>
					<td>
						<input type="submit" value="update"/>
					</td>
				</tr>
			</table>
		</form>
	</xsl:template>
	
	
	<xsl:template match="/update" >
		<div>
			<xsl:choose>
				<xsl:when test="updated='true'">
					<h2>Deployment Updated</h2>
					<b>
					<xsl:if test="jar">
						<p>Module jar-ed to location: <xsl:value-of select="jar"/></p>
					</xsl:if>
					<xsl:if test="expand">
						<p>Module expanded to location: <xsl:value-of select="expand"/></p>
					</xsl:if>
					<xsl:if test="runlevel>0">
						<p>Runlevel changed to: <xsl:value-of select="runlevel"/></p>
					</xsl:if>
					<xsl:if test="runlevel&lt;0">
						<p>Runlevel designation removed</p>
					</xsl:if>
					<xsl:if test="enable='true'">
						<p>Module enabled</p>
					</xsl:if>
					<xsl:if test="enable='false'">
						<p>Module disabled</p>
					</xsl:if>
					</b>
					Please wait a moment for changes to take effect then click
					<input type="button" value="back" onclick="parent.location.href='/tools/deployment/'"/>
					
				</xsl:when>
				<xsl:otherwise>
					<h2>No Changes made</h2>
					<input type="button" value="back" onclick="parent.location.href='/tools/deployment/'"/>
				</xsl:otherwise>
			</xsl:choose>
		</div>
	</xsl:template>
	
	
	
</xsl:stylesheet> 
