package tools.explorer;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.representation.IHDSInversion;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class SpaceExplorerRedirector extends StandardAccessorImpl
{
	public SpaceExplorerRedirector()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	String space=context.getThisRequest().getArgumentValue("space");
		String version=context.getThisRequest().getArgumentValue("version");
		
		IHDSInversion hdsi=context.source("active:moduleListDoc", IHDSInversion.class);
		IHDSNodeList nl=hdsi.getNodes(space);
		String hash=null;
		for(int i=0; i<nl.size(); i++)
		{	IHDSNode n=nl.get(i);
			IHDSNode parent=n.getParent();
			String testv=parent.getFirstValue("version").toString();
			if(testv.equals(version))
			{	hash=(String)n.getParent().getFirstValue("hash");
				break;
			}
		}
		if(hash==null)
		{	throw new NKFException("No module found for "+space+" "+version );			
		}
		else
		{	context.sink("httpResponse:/redirect", "/tools/explore/"+hash);			
		}
	}
	
	
}
